// 2D_PolygonLoopwise.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "NhVector2.h"

// 0 : s -1 : v 1 : v
int CalcLoopwise(	const unsigned int uiCountPoint,
					const CNhPoint2d*  aPoint )
{
	if( 2 >= uiCountPoint )
	{
		return 0;
	}
	unsigned int ui;
	// [i[ȂΉj̓_߂B
	unsigned int uiIndexLeft = 0;
	for( ui = 1; ui < uiCountPoint; ui++ )
	{
		if( aPoint[uiIndexLeft].x > aPoint[ui].x
		 || (aPoint[uiIndexLeft].x == aPoint[ui].x && aPoint[uiIndexLeft].y > aPoint[ui].y ) )
		{
			uiIndexLeft = ui;
		}
	}
	// [_̑O̓_߂iWl[_ƈقȂ_܂Ői߂j
	unsigned int uiIndexLeft_prev;
	if( 0 == uiIndexLeft ){ uiIndexLeft_prev = uiCountPoint - 1; }
	else				  { uiIndexLeft_prev = uiIndexLeft - 1; }
	for( ui = 0; ui < uiCountPoint; ui++ )
	{
		if( aPoint[uiIndexLeft] != aPoint[uiIndexLeft_prev] )
		{
			break;
		}		
		if( 0 == uiIndexLeft_prev ){ uiIndexLeft_prev = uiCountPoint - 1; }
		else					   { uiIndexLeft_prev--; }
	}
	if( ui == uiCountPoint )
	{	// [_ƈقȂO̓_Ȃ˂ׂēWlˑp`͓_ɏkނĂB
		return 0;
	}
	unsigned int uiIndexLeft_next = (uiIndexLeft + 1) % uiCountPoint;
	for( ui = 0; ui < uiCountPoint; ui++ )
	{
		if( aPoint[uiIndexLeft] != aPoint[uiIndexLeft_next] )
		{
			break;
		}
		uiIndexLeft_next = (uiIndexLeft_next + 1) % uiCountPoint; 
	}
	double dOuterProduct = (aPoint[uiIndexLeft] - aPoint[uiIndexLeft_prev]).CalcOuterProduct( aPoint[uiIndexLeft_next] - aPoint[uiIndexLeft] );
	if(      0 > dOuterProduct )
	{	// v
		return -1;
	}
	else if( 0 < dOuterProduct )
	{	// v
		return 1;
	}
	return 0;
}

double CalcPolygonArea(	const unsigned int uiCountPoint,
						const CNhPoint2d*  aPoint )
{
	double dArea = 0;
	for( unsigned int ui = 0; ui < uiCountPoint; ui++ )
	{
		dArea += aPoint[ui].CalcOuterProduct( aPoint[(ui+1)%uiCountPoint] );
	}
	return 0.5 * dArea;
}

// 0 : s -1 : v 1 : v
int CalcLoopwise2(	const unsigned int uiCountPoint,
					const CNhPoint2d*  aPoint )
{
	double dArea = CalcPolygonArea( uiCountPoint, aPoint );
	if(      0 > dArea )
	{	// v
		return -1;
	}
	else if( 0 < dArea )
	{	// v
		return 1;
	}
	return 0;
}

int main(int argc, char* argv[])
{
	const unsigned int uiCountPoint = 5;
	CNhPoint2d aPoint[uiCountPoint] = {	CNhPoint2d(  5.0,  0.0),
										CNhPoint2d( 10.0,  5.0),
										CNhPoint2d(  5.0, 10.0),
										CNhPoint2d(  0.0,  5.0),
										CNhPoint2d(  5.0,  0.0) };

	int iLoopwise  = CalcLoopwise( uiCountPoint, aPoint );
	int iLoopwise2 = CalcLoopwise2( uiCountPoint, aPoint );

	for( unsigned int ui = 0; ui < uiCountPoint; ui++ )
	{
		printf( "point[%d] = (%lf, %lf)\n", ui, aPoint[ui].x, aPoint[ui].y );
	}
	printf( "\n" );
	printf( "Loopwise  = %d (0 : s -1 : v 1 : v) : \n", iLoopwise );
	printf( "Loopwise2 = %d (0 : s -1 : v 1 : v) : \n", iLoopwise2 );

	return 0;

}
