//
// NhVector2.h
//
// xNgi_jev[gNX
// 
// Written by Nobuki HIRAMINE
// Last modified : 2005/09/01
//
#ifndef	_NHVECTOR2_H
#define	_NHVECTOR2_H

#include <FLOAT.H>	// FLT_EPSILON
#include <math.h>	// sqrt()

template <class T> class TNhVector2
{
public:
	T	x, y;

	// RXgN^
	// ftHg
	TNhVector2() : x(0), y(0)
	{}
	// 
	TNhVector2( const T a, const T b ) : x(a), y(b)
	{}

	// zANZX
	// ǂݎp
	const T& operator [] ( const long i ) const
	{
		return *((&x) + i);
	}
	// ݗp
	T& operator [] ( const long i )
	{
		return *((&x) + i);
	}

	// 
	const TNhVector2& operator = ( const TNhVector2& b )
	{
		x = b.x;
		y = b.y;
		return *this;
	}

	// ]
	const TNhVector2 operator - () const
	{
		return TNhVector2( -x, -y );
	}

	// aϏ
	// a
	const TNhVector2 operator + ( const TNhVector2& b ) const
	{
		return TNhVector2( x + b.x, y + b.y );
	}
	// 
	const TNhVector2 operator - ( const TNhVector2& b ) const
	{
		return TNhVector2( x - b.x, y - b.y );
	}
	// xNg x l
	const TNhVector2 operator * ( const T t ) const
	{
		return TNhVector2( x * t, y * t );
	}
	//  l x xNg
	friend inline const TNhVector2 operator * ( const T t, const TNhVector2& b )
	{
		return b * t;
	}
	// 
	const TNhVector2 operator / ( const T t ) const
	{
		if( 0.0 == t )
		{	// [́AɏŊ肽Ɖ߂āAKFLT_EPSILONŊZ{
			assert( !"[" );	// AT[gɂȂP[X́AĂяoŖ{ĂяowOxɑΏjŁB
			return TNhVector2( x/FLT_EPSILON, y/FLT_EPSILON );
		}
		return TNhVector2( x / t, y / t );
	}

	// gɑ΂aϏ
	// a
	const TNhVector2& operator += ( const TNhVector2& b ) 
	{
		x += b.x;
		y += b.y;
		return *this;
	}
	// 
	const TNhVector2& operator -= ( const TNhVector2& b ) 
	{
		x -= b.x;
		y -= b.y;
		return *this;
	}
	// 
	const TNhVector2& operator *= ( const T t ) 
	{
		x *= t;
		y *= t;
		return *this;
	}
	// 
	const TNhVector2& operator /= ( const T t )
	{
		if( 0.0 == t )
		{	// [́AɏŊ肽Ɖ߂āAKFLT_EPSILONŊZ{
			assert( !"[" );	// AT[gɂȂP[X́AĂяoŖ{ĂяowOxɑΏjŁB
			x /= FLT_EPSILON;
			y /= FLT_EPSILON;
			return *this;
		}
		x /= t;
		y /= t;
		return *this;
	}

	// 
	const T CalcInnerProduct( const TNhVector2& b ) const
	{
		return x * b.x + y * b.y;
	}

	// O
	const T CalcOuterProduct( const TNhVector2& b ) const
	{
		return x * b.y - y * b.x;
	}

	// 
	const T CalcLengthSquared() const
	{
		return this->CalcInnerProduct(*this);
	}
	const T CalcLength() const
	{
		return (T)sqrt( this->CalcLengthSquared() );
	}

	// PʃxNg̎擾
	const TNhVector2 CalcNormal() const
	{
		assert( 0 != this->CalcLength() );
		return  (*this) / this->CalcLength();
	}

	// PʃxNg
	const TNhVector2& Normalize()
	{
		assert( 0 != this->CalcLength() );
		(*this) /= this->CalcLength();
		return *this;
	}

	// r
	// 
	const bool operator == ( const TNhVector2& b ) const
	{
		return( b.x==x && b.y==y );
	}

	// قȂ邩
	const bool operator != ( const TNhVector2& b ) const
	{
		return !( b == *this );
	}
	// 
	bool operator < ( const TNhVector2& b ) const
	{
		if( y < b.y )		{ return true; }
		else if( y > b.y )	{ return false; }
		else{	// xƂ͂wŔr
			if( x < b.x )		{ return true; }
			else if( x > b.x )	{ return false; }
			else				{ return false; }// wAxƂ́AFALSE
		}
	}
	// 傫
	bool operator > ( const TNhVector2& b ) const
	{
		if( y > b.y )		{ return true; }
		else if( y < b.y )	{ return false; }
		else{	// xƂ͂wŔr
			if( x > b.x )		{ return true; }
			else if( x < b.x )	{ return false; }
			else				{ return false; }// wAxƂ́AFALSE
		}
	}

};

typedef TNhVector2<double>	CNhVector2d;
typedef CNhVector2d			CNhPoint2d;

typedef TNhVector2<float>	CNhVector2f;
typedef CNhVector2f			CNhPoint2f;

#endif	/*_NHVECTOR2_H*/
